# encoding:utf-8

# We enable the new python 3 print syntax
from __future__ import print_function

import sys, os, time

# from library import convert_xml_to_library

libspath = os.path.dirname(os.path.abspath(__file__))
basepath = os.path.dirname(libspath)

msgs = []

repo = librarymanager.repositories[0]


def isError():
    msgs = system.get_message_objects("", Severity.FatalError | Severity.Error)
    if len(msgs):
        return True
    return False


installed_libs = []

import re
import os
import json

var_sections_re = "[ \t]*(VAR_GLOBAL|VAR_IN_OUT|VAR_INPUT|VAR_OUTPUT|VAR|VAR_RETAIN|VAR_GLOBAL_RETAIN)(.*)\n([\s\S]*?)END_VAR"
var_re = "\s*(\w+)\s*:\s*([0-9a-zA-Z\s\[\]\.]+\w)\s*;"

proj = projects.primary

# print(proj.path)
name = os.path.basename(proj.path).split(".")[0]
p = os.path.split(proj.path)[0]
jsonFileName = os.path.join(p, name + ".json")
# print(jsonFileName)

with open(jsonFileName, "r") as f:
    settings = json.load(f)

settings["POUs"] = settings["POUs"].split()
settings["GVLs"] = settings["GVLs"].split()

# print(settings)

initial = []
synchro = []
output = []
pou_to_insert_code = []


def parse_device_param(param, level):
    # print("- " * level + param.visible_name + " " + str(param.parameter.id))
    if param.is_mappable_io:
        if param.io_mapping:
            # print("- " * (level + 1) + "mapping " + str(param.io_mapping.variable))
            if param.io_mapping.variable:
                # print(param.io_mapping.variable)
                initial.append(param.io_mapping.variable)
                if param.parameter.channel_type == ChannelType.Input or ((param.parameter.id >= 3000) and (param.parameter.id < 4000)):
                    synchro.append(param.io_mapping.variable)
                elif param.parameter.channel_type == ChannelType.Output:
                    output.append(param.io_mapping.variable)
                return
    if param.has_sub_elements:
        for i in param:
            parse_device_param(i, level + 1)


def parse_device_params(params, level):
    # print("- " * level + "params " + str(params))
    for p in params:
        parse_device_param(p, level + 1)


def get_variables(treeobj, level=0):
    if treeobj.has_textual_declaration:
        if treeobj.get_name() in settings["POUs"]:
            sections = re.findall(var_sections_re, treeobj.textual_declaration.text)
            for sec in sections:
                # print (sec)
                if sec[0] == "VAR" and sec[1] == "":
                    vars = re.findall(var_re, sec[2])
                    initial.extend([treeobj.get_name() + "." + i[0] for i in vars])
                 # print(vars)
        if treeobj.get_name() in settings["GVLs"]:
            sections = re.findall(var_sections_re, treeobj.textual_declaration.text)
            for sec in sections:
                # print(sec)
                if sec[0] == "VAR_GLOBAL" and sec[1] == "":
                    vars = re.findall(var_re, sec[2])
                    initial.extend([treeobj.get_name() + "." + i[0] for i in vars])
                   # print(vars)
        if treeobj.get_name() == settings["InitFunction"]:
            pou_to_insert_code.append(treeobj)
            # print("found init function")

    if treeobj.is_device:
        # print("- "*level + "id = " + str(treeobj.get_device_identification()))
        cons = treeobj.connectors
        for c in cons:
            # print("- "*(level + 1) + "con " + str(c))
            parse_device_params(c.host_parameters, level + 2)

    # if treeobj.is_task_configuration:
    #     print("task")

    for child in treeobj.get_children(False):
        get_variables(child, level + 1)


for obj in proj.get_children():
    get_variables(obj)

if not pou_to_insert_code:
    print()
# print(initial)
# print(synchro)
# print(output)

templ = "NftRdcy.NftRdcyImpl.AreaRegister(ADR(%s), SIZEOF(%s), NftRdcy.NftRdcyItfs.AREA_TYPE.AREA_%s);\n"

tmpl_re = "[\w\t \.]+(?i)\\bAreaRegister\\b\s*\(\s*(?i)\\bADR\\b\s*\(\s*(?i)\\b%s\\b\s*\)\s*," \
            "\s*(?i)\\bSIZEOF\\b\s*\(\s*(?i)\\b%s\\b\s*\)\s*,.*(?i)\\bAREA_TYPE\\b\s*\.\s*(?i)\\bAREA_%s\\b\s*\)\s*;\s*"
header_initial = "// ------ INITIAL ------\n"
header_synchro = "// ------ SYNCHRO ------\n"
header_output = "// ------ OUTPUT  ------\n"

# print (pou_to_insert_code)
txt_impl = pou_to_insert_code[0].textual_implementation

text_ = txt_impl.text
# print(text_)


def add_section(str_to_add, header, vars, area_type_str):
    pos = str_to_add.find(header)
    if pos >= 0:
        pos += len(header)
    else:
        str_to_add += header
        pos = len(str_to_add)

    vars_initialization = ""
    for var in vars:
        f = tmpl_re % (var, var, area_type_str)
        # print(f)
        fnd = re.findall(f, str_to_add)
        # print(fnd)
        if fnd:
            # print ("continue")
            continue
        vars_initialization += templ % (var, var, area_type_str)
    return str_to_add[0:pos] + vars_initialization + str_to_add[pos:len(str_to_add)]

text_ = add_section(txt_impl.text, header_initial, initial, "INITIAL")
txt_impl.replace(text_)
text_ = add_section(txt_impl.text, header_synchro, synchro, "SYNCHRO")
txt_impl.replace(text_)
text_ = add_section(txt_impl.text, header_output, output, "OUTPUT")
txt_impl.replace(text_)
